#include "gp2xjoy.h"
#include "gp2xgp32compat.h"

#include <fcntl.h>
#include <unistd.h>
#include <SDL/SDL.h>
#include <sys/soundcard.h>

#define GP2XJOY_U 1
#define GP2XJOY_UL 2
#define GP2XJOY_L 4
#define GP2XJOY_DL 8
#define GP2XJOY_D 16
#define GP2XJOY_DR 32
#define GP2XJOY_R 64
#define GP2XJOY_UR 128

//static int fd = -1;
static int strategy = 1;

static unsigned int buf;

void readAllJoy(int * x, int * y, int * buttons)
{
#ifdef NATY
	*x = 0;
	*y = 0;
	*buttons = 0;
	int count;
	SDL_PumpEvents();
	Uint8 * state = SDL_GetKeyState(&count);
	if (state[SDLK_UP] || state[SDLK_i] )
		*y=-1;
	else if (state[SDLK_DOWN] || state[SDLK_k])
		*y=1;
	else if (state[SDLK_LEFT] || state[SDLK_j])
		*x=-1;
	else if (state[SDLK_RIGHT] || state[SDLK_l])
		*x=1;
	
	if (state[SDLK_a])
		*buttons |= GPC_VK_FA;
	if (state[SDLK_b])
		*buttons |= GPC_VK_FB;
	if (state[SDLK_r])
		*buttons |= GPC_VK_FR;
	if (state[SDLK_l])
		*buttons |= GPC_VK_FL;
	if (state[SDLK_s])
		*buttons |= GPC_VK_START;
	if (state[SDLK_e])
		*buttons |= GPC_VK_SELECT;

	//printf("x:%d y:%d\n",*x,*y);
	return;
#endif	
	
	//if (fd == -1)
	//	fd = open ("/dev/GPIO", O_RDONLY);

	//read (fd, buf, 4);
	buf = gp2x_joystick_read();

	int xoff = 0;
	int yoff = 0;
	int joy = buf&0xff;
	if (joy&GP2XJOY_U)
		yoff = -1;
	else if (joy&GP2XJOY_R)
		xoff = +1;
	else if (joy&GP2XJOY_D)
		yoff = +1;
	else if (joy&GP2XJOY_L)
		xoff = -1;
	else if (joy&GP2XJOY_UR)
		{xoff = +1; yoff = -1;}
	else if (joy&GP2XJOY_DR)
		{xoff = +1; yoff = +1;}
	else if (joy&GP2XJOY_DL)
		{xoff = -1; yoff = +1;}
	else if (joy&GP2XJOY_UL)
		{xoff = -1; yoff = -1;}

	*x = xoff;
	*y = yoff;
	*buttons = (buf&0xff00)>>8;
}

void readJoy(int * x, int * y)
{
	int dummy;
	readAllJoy(x, y, &dummy);
}

int getButtons()
{
	int dx,dy,out;
	readAllJoy(&dx,&dy,&out);
	return out;
}

int getX()
{
	int dx,dy,out;
	readAllJoy(&dx,&dy,&out);
	return dx;
}

int getY()
{
	int dx,dy,out;
	readAllJoy(&dx,&dy,&out);
	return dy;
}

int joyPressed()
{
	int x,y,out;
	readAllJoy(&x,&y,&out);
	return (out|(x!=0)|(y!=0));
}




