#include "atari_gp32.h"

#include "gpmain.h"
#include "gp32.h"

#include <stdlib.h>
#include <stdio.h>

#include "log.h"
#include "kbdrv.h"

#ifndef RANDOM
#define RANDOM 31000
#endif

//GPDRAWSURFACE gpDraw[2];

//int i, backbuf, n_tick;
GPDRAWSURFACE testSurface, testSurface2;

#define DEBUG(x,y) sprintf(testPrintBuffer, x,y);testPrint(testPrintBuffer);
extern char testPrintBuffer[];

void _init();
int main(int argc, char * argv[]);

//static int timerCount = 0;

static volatile unsigned int rtcTick = 0;

static void rtc(void)  __attribute__ ((interrupt ("IRQ")));
static
void rtc()
{
	rtcTick++;
}

void setuprtc()
{
	// Set up RTC
	rCLKCON |= 0x800;
	rTICINT = 0x81;
	ARMDisableInt();
	installIRQ(8, rtc);
	ARMEnableInt();
}

int timerTick = 0;
void callback()
{
	timerTick++;
}

int gptc = 0;
int atc = 0;

void dumpTimerRegs()
{
	// Lets dump timer regs...
	// Input is pclk
	// TCNTBn - initial
	// TCNTn - count down to 0
	// TOUTn - turn off externing PWM stuff
	// TCFG0 - 15:8 - prescaler 234 7:0 prescaler 01
	// TCFG1 - mux? - dump anyway just in case!
	// TCON - update modes
	Aprint("Timer regs: %d", GpPClkGet());
	Aprint("TCNTB0:%x", rTCNTB0);
	Aprint("TCNTB1:%x", rTCNTB1);
//	Aprint("TCNTB2:%x", rTCNTB2);
//	Aprint("TCNTB3:%x", rTCNTB3);
	Aprint("TCNTB4:%x", rTCNTB4);
	Aprint("TCON:%x", rTCON);
	Aprint("prescaler 234:%x", (rTCFG0&0xFF00) >>8);
	Aprint("presscaler 02:%x\n", (rTCFG0&0x00FF));
	Aprint("TCFG1:%x", rTCFG1);
	Aprint("LCDCON1:CLKVAL:%x", rLCDCON1&0x3FFFF);
	Aprint("IISPSR:%x", rIISPSR);
	Aprint("IISMOD:%x",rIISMOD);
}

void GpMain(void * arg) 
{
	_init();
/*	GpFatInit();
	GpRelativePathSet("gp:\\");
	dumpTimerRegs();*/
	main(0,0);

/*
	GpFatInit();
	GpRelativePathSet("gp:\\");

	setuprtc();

	GpLcdSurfaceGet(&testSurface, 0);
	GpTimerOptSet(1, 250, 0, callback);
	dumpTimerRegs();

	Aprint("Clock M:%d H:%d P:%d\n", GpMClkGet(), GpHClkGet(), GpPClkGet());

	timerTick = 0;
	rtcTick = 0;
	gptc = GpTickCountGet();
	GpTimerSet(1);
	while (rtcTick < 1000);
	Aprint("orig rtcTick %d timerTick %d post %d verify %f\n\n\n", rtcTick, timerTick, GpTickCountGet()-gptc, GpPClkGet()*100.0/(float)origPClk);
	GpTimerKill(1);

	GP32_SetClock(GPMHZ_156);
	timerTick = 0;
	rtcTick = 0;
	gptc = GpTickCountGet();
	GpTimerSet(1);
	while (rtcTick < 1000);
	Aprint("156 rtcTick %d timerTick %d post %d verify %f\n\n\n", rtcTick, timerTick, GpTickCountGet()-gptc, GpPClkGet()*100.0/(float)origPClk);

	GP32_SetClock(GPMHZ_132);
	timerTick = 0;
	rtcTick = 0;
	gptc = GpTickCountGet();
	GpTimerSet(1);
	while (rtcTick < 1000);
	Aprint("132 rtcTick %d timerTick %d post %d verify %f\n\n\n", rtcTick, timerTick, GpTickCountGet()-gptc, GpPClkGet()*100.0/(float)origPClk);

	GP32_SetClock(GPMHZ_99);
	timerTick = 0;
	rtcTick = 0;
	gptc = GpTickCountGet();
	GpTimerSet(1);
	while (rtcTick < 1000);
	Aprint("99 rtcTick %d timerTick %d post %d verify %f\n\n\n", rtcTick, timerTick, GpTickCountGet()-gptc, GpPClkGet()*100.0/(float)origPClk);

	GP32_SetClock(GPMHZ_80);
	timerTick = 0;
	rtcTick = 0;
	gptc = GpTickCountGet();
	GpTimerSet(1);
	while (rtcTick < 1000);
	Aprint("80 rtcTick %d timerTick %d post %d verify %f\n\n\n", rtcTick, timerTick, GpTickCountGet()-gptc, GpPClkGet()*100.0/(float)origPClk);

	GP32_SetClock(GPMHZ_67);
	timerTick = 0;
	rtcTick = 0;
	gptc = GpTickCountGet();
	GpTimerSet(1);
	while (rtcTick < 1000);
	Aprint("67 rtcTick %d timerTick %d post %d verify %f\n\n\n", rtcTick, timerTick, GpTickCountGet()-gptc, GpPClkGet()*100.0/(float)origPClk);
*/
	exit(0);

/*
	OpenUSB();
	InstallISR();*/
/*
	asm volatile("
			mov	r0, #0x01
			ldr	r1, [r0]

		"
		:
		:
		:"r0", "r1");

*/
//	Atari_Initialise(0, 0);

	// Init filesystem
/*	GpFatInit();
	GpRelativePathSet("gp:\\");


	GpLcdSurfaceGet(&testSurface, 0);
	GpRectFill(NULL, &testSurface, 0,0,320,240,0);*/

//	FILE * x = fopen("mem:test.log", "w");
//	fprintf(x, "Test");
//	fclose(x);

//	Aprint("Test");

/*	GPFILEATTR atrib;
	memset(&atrib, 0, sizeof(atrib));
	ERR_CODE code = GpFileAttr("a800.log", &atrib);
	DEBUG("XXEXISTS:%x\n", code);

	FILE * file = fopen("a800.log", "w");
	for (;;);
	char buffer[256] = "Test";
//	char buffer[256];
//	sprintf(buffer, "%s\n", "Test");
	fwrite(buffer, 4, 1, file);
//	fclose(file);
//	fprintf(file, "%s\n", "Test");
	
	for (;;);*/

//	strcpy(buffer, "Test");
//	testPrint(buffer);
//	if (x)
//		GpRectFill(NULL, &surface, 0,0,320,240,0x3456);
//	else
//	GpSurfaceSet(&testSurface);

//	fprintf(x, "Blurgle FUCKE ME CARROTS\n");
/*	fputs("ARSE BISCUITS\n", x);
	Aprint("SOMETHING AT LEAST2\n");*/
//	fclose(x);

/*	scr = (char *) malloc(384*240);
	for (i=0; i<2000; ++i)
	{
		Atari_DisplayScreen(scr);
	}*/

/*	GpGraphicModeSet(16, NULL);
	GpLcdSurfaceGet(&surface, 0);
	if (gm_malloc(1024*512*13))
		GpRectFill(NULL, &surface, 0,0,320,240,0x3456);
	else
		GpRectFill(NULL, &surface, 0,0,320,240,0);
	GpSurfaceSet(&surface);*/

/*	GPDRAWSURFACE surface;
	Atari_Initialise(0,0);
	GpGraphicModeSet(16, NULL);
	GpLcdSurfaceGet(&surface, 0);

	GpSurfaceSet(&surface);

	for (;;)
	{
	if (Atari_TRIG(0))
	{
		GpRectFill(NULL, &surface, 0,0,320,240,0xffff);
	}
	else
	{
		GpRectFill(NULL, &surface, 0,0,320,240,0x0000);
	}
	}
*/

/*	GPDRAWSURFACE surface;
	Atari_Initialise(0,0);
	GpGraphicModeSet(16, NULL);
	GpLcdSurfaceGet(&surface, 0);

	GpSurfaceSet(&surface);

	for (;;)
	{
	FILE * f;
	//malloc(60000);
	//f = fopen("/atarixl.rom", "rb");
	
	F_HANDLE gpfh;
	GpFatInit();
	GpRelativePathSet("gp:\\");
	if (GpFileOpen("atarixl.rom",OPEN_R,&gpfh)==SM_OK)
	{
		GpRectFill(NULL, &surface, 0,0,320,240,0xffff);
	}
	else
	{
		GpRectFill(NULL, &surface, 0,0,320,240,0x0000);
	}
	}
*/
/*
	GpGraphicModeSet(8, NULL);
	GpLcdSurfaceGet( &gpDraw[0], 0);
	GpLcdSurfaceGet( &gpDraw[1], 1);
	GpSurfaceSet( &gpDraw[1]);
	GpLcdEnable();

	backbuf = 0;

	GpSrand(RANDOM);

	while(1) 
	{
		GpRectFill(NULL, &gpDraw[backbuf], 0, 0, 320, 240, 0x00);


    for (i=0; i<200; i++) 
		{
    		int x1 = GpRand()%320;
    		int x2 = GpRand()%320;
		    int y1 = GpRand()%240;
		    int y2 = GpRand()%240;
				int c = GpRand();
						
				GpRectFill(NULL, &gpDraw[backbuf], x1, y1, x2, y2, c);
				//GpPointSet(&gpDraw[backbuf], x, y, c);
    }

    GpSurfaceFlip( &gpDraw[backbuf]);
    backbuf ^= 1;*/
   // n_tick = GpTickCountGet();
   // while ( ( GpTickCountGet() - n_tick ) < 30)
   // ;
 // }
}
