#include "menu_container.h"

#include "menu_factory.h"
#include "menu_amenu.h"

MenuContainer::MenuContainer():
	d_blocking(0)
{
}

MenuContainer::~MenuContainer()
{
	std::vector<AMenu *>::const_iterator i;
	for (i=d_menus.begin(); i!=d_menus.end(); ++i)
		delete *i;
}

void MenuContainer::loadMenu(const std::string & filename)
{
	d_menus.clear();

	// Add default -> press all buttons to get back to main menu
	AMenu * menu = AMenuFactory::build("H:L|R|B|A|START|SELECT:UI:100");
	d_menus.push_back(menu);

	FILE * file = fopen(filename.c_str(), "r");
	if (file)
	{
		fseek(file, 0, SEEK_END);
		int length = ftell(file);
		fseek(file, 0, SEEK_SET);

		char * fileMem = (char *)malloc(length);
		fread(fileMem, length, 1, file);

		char * lineBuffer = (char *) malloc(1025);
		int lineCount = 0;
		for (int i=0; i<length; ++i)
		{
			if ((lineCount>=1024) || fileMem[i] == '\n' || fileMem[i] == '\r' )
			{
				lineBuffer[lineCount] = 0;
				AMenu * menu = eachLine(lineBuffer);
				if (menu)
					d_menus.push_back(menu);
				lineCount = 0;
				continue;
			}
			lineBuffer[lineCount++] = fileMem[i];
		}

		free(fileMem);
		free(lineBuffer);

		fclose(file);
	}
}

///////////////////////////////////////////////////
// Internal
AMenu * MenuContainer::eachLine(const std::string & line) const
{
	if (line.empty())
		return 0;

	if (line[0] == '#')
		return 0;

	return AMenuFactory::build(line);
}

